var docInfo = JSON.parse(window.localStorage.getItem('wlyyAgent'));
function showSuccessMessage(msg) {
	layer.msg(msg, {
		icon: 1
	})
}

function showErrorMessage(msg) {
	layer.msg(msg, {
		icon: 5
	})
}

function showWarningMessage(msg) {
	layer.msg(msg, {
		icon: 2
	})
}

function showInfoMessage(msg) {
	layer.msg(msg, {
		icon: 6
	})
}
var TemplateItems = {
	template: '<div style="height: 100%;">\
					<el-dialog\
						title="计划时间"\
						:visible.sync="dialogVisible"\
						width="30%"\
						:before-close="handleClose">\
						<div>\
							<div>任务项目：电话/短信关怀</div>\
							<div>\
								<el-select v-model="seletc" placeholder="请选择">\
									<el-option\
										v-for="item in options"\
										:key="item.value"\
										:label="item.label"\
										:value="item.value">\
									</el-option>\
								</el-select>\
							</div>\
						</div>\
						<span slot="footer" class="dialog-footer">\
							<el-button @click="dialogVisible = false">取 消</el-button>\
							<el-button type="primary" @click="dialogVisible = false">确 定</el-button>\
						</span>\
					</el-dialog>\
    				<div class="title-name c-f16">\
	    				<span class="c-vam">{{name}}</span>\
	    			</div>\
	    			<div v-show="!items.length" class="c-t-center" style="margin-top: 200px;">\
	    				<img src="../../../images/fanhui_icon.png" class="c-vam"/>请在左侧“服务项”列表中选择\
	    			</div>\
	    			<div class="template-items" v-show="items.length">\
	    				<div class="item-card ptb10 plr15 mt10" v-for="(o, i) in items">\
		    				<div class="c-nowrap">{{o.name}}</div>\
			    			<div class="c-row c-f14 mt5">\
						        <div class="c-50">\
						        	<span class="c-909090">医&emsp;&emsp;院:</span>\
						        	<span class="c-909090">待选择</span>\
						        </div>\
						        <div class="c-50">\
						        	<span class="c-909090">执行人员:</span>\
						        	<span class="c-909090">待选择</span>\
						        </div>\
						    </div>\
						    <div class="c-row c-f14 mt5">\
						        <div class="c-50">\
						        	<span class="c-909090">计划时间:</span>\
						        	<span class="c-909090">待选择</span><img class="ml15" @click="dialogVisible = true" style="width:16px;height: 16px;vertical-align: middle;display:none;" src="../../../images/bianji_icon.png"></img>\
						        </div>\
						        <div class="c-50 setSelect">\
									<span class="c-909090">费&emsp;&emsp;用:</span>\
									<el-input-number v-model="o.expense" :step="1" :min="0" size="mini"></el-input-number>&emsp;元\
						        </div>\
						    </div>\
						    <img v-if="name!=\'系统模板\'" src="../../../images/qingchu_icon.png" class="item-delete-btn" @click.stop="deleteItem(o, i)"/>\
	    				</div>\
	    			</div>\
	    			<div class="foot-btns">\
			    		<a class="delete-btn c-t-center mr50" @click="deleteTemplate">\
			    			删除模板\
			    		</a>\
			    		<a class="save-btn c-t-center" @click="saveTemplate">\
			    			保存模板\
			    		</a>\
		    		</div>\
    			</div>',
    props: [],
    data: function() {
        return {
        	name: '',
        	items: [],
        	isNew: null,
			templateId: "",
			dialogVisible:false,
			item: null,
			seletc:'',
			frequencysList1:[{"code":"qd_10-week1","name":"1周/次","type":1,mode:"week"},
			{"code":"qd_10-week1","name":"2周/次","type":2,mode:"week"},
			{"code":"qd_10-month1","name":"1月/次","type":1,mode:"month"},
			{"code":"qd_10-month1","name":"2月/次","type":2,mode:"month"},
			{"code":"qd_10-month1","name":"3月/次","type":3,mode:"month"}],  //频次列表-multiple	
			options:[{label:'0',value:'0'}]
        }
    },
    beforeRouteEnter: function (to, from, next) {
	    next(function(vm) {
	    	var query = vm.$route.query
	    	vm.name = query.name || '模板未命名',
	    	vm.templateId = query.templateId
	    	if(from.path != "/template-item-detail" || from.path == "/") {
	    		vm.items = []
	    	}
	    	
	    	if(vm.isNew == true || vm.isNew === "true") {
	    		vm.isNew = true
	    	} else {
	    		vm.isNew = false
	    	}
	    })
	},
	created: function() {
		var vm = this
		EventBus.$on("add-template-item", function(o) {
			vm.items.push(o)
			_.map(vm.items, function (item) {
				item.plan=[]
				// 过滤有执行时间的数组
				var arr=[]
				arr=_.filter(item.list,function(ee){
					return ee.executeTimes
				})    
				item.num=arr.length
				if(item.num){
					item.plan =item.list||[]
					item.remark=item.list[0].remark
					_.map(item.plan,function(item2){
						item2.executeTimes?item2.executeTimesArr=item2.executeTimes.split(','):''
						item2.mode='multiple'    //模板
						item2.show=false
						item2.doctorName=item2.type==1?'家庭医生':'专科医生'
						item2.doctor=item2.type
						_.map(vm.frequencysList1,function(it){
							if(it.name==item2.frequencyName){
								item2.frequencyName?item2.frequencyCode=it.code:''
							}
						})
						item2.date=_.map(item2.executeTimesArr,function(item3){
							return item3.substring(0,item3.length-6)
							 
						})
						return item2
					})  
				}
				return item
			})
		})
	},
    mounted: function() {
    	var vm = this
		
    },
    methods: {
    	deleteItem: function(o, i) {
    		var vm = this
    		o.enable = true
			vm.items.splice(i, 1)
			EventBus.$emit("delete-template-item", o, i)
		},
		handleClose:function(){

		},
    	saveTemplate: function() {
			var vm = this
			if(this.name=='系统模板'){
				showErrorMessage('不能编辑系统模板！')
				return false
			}
			var params = []
            _.each(vm.items, function (item, index) {
                if (item.plan && item.plan.length) {
                    _.each(item.plan, function (citem, cindex) {
                        var param = {
                            'templateId': vm.templateId,
                            "hospitalServiceItemId": item.code,
                            "type": citem.type,  //1家医2专医
                            "executeTimes": citem.executeTimes,
                            "frequencyCode": citem.frequencyCode.split("-")[0],
                            'frequencyName':citem.frequencyName,
                            'dateName':citem.dateName,
                            'dateCode':citem.dateCode,
							"timeType": 0,   //1白天2晚上0全天
							'expense':item.expense,
							"remark": item.remark,
                        }
                        params.push(param)
                    })
                } else {
                    var param = {
                        'templateId': vm.templateId,
                        "hospitalServiceItemId": item.code,
                        "type": '',  //1家医2专医
                        "executeTimes": "",
                        "frequencyCode": "",
						"timeType": 0,   //1白天2晚上0全天
						'expense':item.expense,
                        "remark": ""
                    }
                    params.push(param)
                }
            })
            if (params.length == 0) {
                mui.toast("请选择配置康复服务项");
                return false
            }
    		vm.loading.showModal()
    		rehaAPI.createTemplateDetail({
    			doctor: docInfo.uid,
				json:JSON.stringify(params),
    			type: vm.isNew?"create":"edit"
    		}).then(function(res) {
    			if(res.status == 200) {
    				vm.loading.close()
					showSuccessMessage('保存成功')
    				EventBus.$emit("refresh-index")
        			vm.$router.replace("/")
    			} else {
    				vm.loading.close()
    				showErrorMessage(res.msg)
    			}
    		}).catch(function(e) {
    			vm.loading.close()
    			console.error(e)
    		})
    	},
    	deleteTemplate: function() {
    		var vm = this
			if(this.name=='系统模板'){
				showErrorMessage('不能删除系统模板！')
				return false
			}
			layer.confirm('确定删除该模板？', {
				btn: ['确认','取消'] //按钮
				}, function(){
					vm.loading.showModal()
					rehaAPI.deleteTemplate({
						templateId: vm.templateId
		            }).then(function(res) {
		            	vm.loading.close()
		            	if(res.status == 200) {
							showSuccessMessage('删除成功')
		            	} else {
							showErrorMessage(res.msg)
		            	}
        				EventBus.$emit("refresh-index")
        				vm.$router.replace("/")
		        	}).catch(function(e) {
		        		vm.loading.close()
		        		console.error(e)
		        	})
				}, function(){
			});
    	},
    	toDetail: function(o) {
    		var vm = this
    		vm.item = o
    		vm.$router.push({
    			path:"/template-item-detail",
    			query: {
    				templateId: vm.templateId,
    				itemId: o.code
    			}
    		})
    		
    	}
    },
//  watch: {
//	    '$route': function (to, from) {
//	    	var vm = this
////	    	if(to.path == "/template-item-detail" && (from.path != "/template-item-detail" || from.path == "/")) {
////	    		EventBus.$emit("show-item-detail", vm.item)
////	    	}
//			if(to.path == "/template-item-detail") {
//	    		EventBus.$emit("show-item-detail", vm.item)
//	    	}
//	    }
//	 }
}